/*---------------------------------------------------------------------------*
  Project:  NintendoWare
  File:     eft_Particle.vsh
  
  Copyright (C)2011-2012 Nintendo All rights reserved.
  
  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.
  
  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/



//---------------------------------------------------
// [U[Ǝ̐EW𒲐( JX^}CY\ )
//---------------------------------------------------
#ifndef USE_USR_ADJUSTMENT_WORLD_POSITION
void AdjustmentWorldPosition(){}
#endif

//---------------------------------------------------
// [U[Ǝ̒_ŏI( JX^}CY\ )
//---------------------------------------------------
#ifndef USE_USR_FINAL_ADJUSTMENT_VERTEX_PROCSS
void FinalAdjustmentVertexProcess(){}
#endif

//---------------------------------------------------
// [JWn̖@xNg擾( JX^}CY\ )
//---------------------------------------------------
#ifndef USE_USR_GET_LOCAL_NORMAL
vec3 GetLocalNormal()
{
#ifndef MESH_TYPE_PRIMITIVE
    return vec3( 0, 0, 1 );
#else
    return v_inNormal;
#endif
}
#endif

//---------------------------------------------------
// [JWn̐ڐxNg擾( JX^}CY\ )
//---------------------------------------------------
#ifndef USE_USR_GET_LOCAL_TANGENT
vec3 GetLocalTangent()
{
    return vec3( 1, 0, 0 );
}
#endif

//---------------------------------------------------
// [JWn̏]@xNg擾( JX^}CY\ )
//---------------------------------------------------
#ifndef USE_USR_GET_LOCAL_BINORMAL
vec3 GetLocalBinormal()
{
    return vec3( 0, 1, 0 );
}
#endif

//---------------------------------------------------
// v~eBũXP[Z擾( JX^}CY\ )
//---------------------------------------------------
#ifndef USE_USR_GET_PRIMITIVE_SCALE_Z
float GetPrimitiveScaleZ()
{
    return ptclScaleX;
}
#endif








//------------------------------------------------------------------------------
// ϊs
//------------------------------------------------------------------------------
#ifdef TARGET_WINDOWS
    mat4 matTexture = mat4( 0.5,  0.0, 0.0, 0.0, 
                            0.0,  0.5, 0.0, 0.0, 
                            0.0,  0.0, 0.5, 0.0, 
                            0.5,  0.5, 0.5, 1.0 );
#endif
#ifdef TARGET_CAFE
    mat4 matTexture = mat4(   0.5,  0.0, 0.0, 0.0, 
                              0.0, -0.5, 0.0, 0.0, 
                              0.0,  0.0, 0.5, 0.0, 
                              0.5,  0.5, 0.5, 1.0 );
#endif

//------------------------------------------------------------------------------
// ]s񐶐
//------------------------------------------------------------------------------
mat4 MakeRotationMatrix( float x, float y, float z )
{
    mat4 rotMat;

    // YZX
    float sinX = sin( -x );
    float cosX = cos( -x );
    float sinY = sin( -y );
    float cosY = cos( -y );
    float sinZ = sin( -z );
    float cosZ = cos( -z );

    float opt1 = cosY * sinZ;
    float opt2 = sinY * sinZ;

    rotMat[0][0] =  cosY * cosZ; 
    rotMat[0][1] = -opt1 * cosX + sinY * sinX; 
    rotMat[0][2] =  opt1 * sinX + sinY * cosX; 
    rotMat[0][3] =  0.0; 

    rotMat[1][0] =  sinZ; 
    rotMat[1][1] =  cosZ * cosX; 
    rotMat[1][2] = -cosZ * sinX; 
    rotMat[1][3] =  0.0; 

    rotMat[2][0] = -sinY * cosZ; 
    rotMat[2][1] =  opt2 * cosX + cosY * sinX; 
    rotMat[2][2] = -opt2 * sinX + cosY * cosX; 
    rotMat[2][3] =  0.0; 

    rotMat[3][0] = 0.0; 
    rotMat[3][1] = 0.0; 
    rotMat[3][2] = 0.0; 
    rotMat[3][3] = 1.0; 

    return rotMat;
}

//------------------------------------------------------------------------------
// p[eBN_VF[_
//------------------------------------------------------------------------------
void main(void)
{
    vec3	upVector;
    vec3	basisX;
    vec3	basisY;
    vec3	basisZ;
    mat4	rotMat;
    float	len;	
	
    mat4 matTemp = mat4(   1.0,  0.0, 0.0, 0.0, 
                           0.0,  1.0, 0.0, 0.0, 
                           0.0,  0.0, 1.0, 0.0, 
                           0.0,  0.0, 0.0, 1.0 );
    
    mat4 matVelLook = mat4( 1.0,  0.0, 0.0, 0.0, 
                            0.0,  1.0, 0.0, 0.0, 
                            0.0,  0.0, 1.0, 0.0, 
                            0.0,  0.0, 0.0, 1.0 );

    // XP[
    vec4 scaledPos;
    scaledPos.x = ( v_inPos.x + rotBasis.x )  * ptclScaleX;
    scaledPos.y = ( v_inPos.y + rotBasis.y )  * ptclScaleY;
    scaledPos.z = v_inPos.z;
    scaledPos.w = 1.0;

    // v~eBu^Cv̏ꍇ́AXP[ZύX
    // ftHgł́Av_inScl.x  z ɓKpB
#ifdef MESH_TYPE_PRIMITIVE
    scaledPos.z *= GetPrimitiveScaleZ();
#endif

    //--------------------------------------------------------------
    // _ϊ - ʏ
    //--------------------------------------------------------------
#if ( VERTEX_TRANSFORM_MODE == VERTEX_TRANSFORM_MODE_BILLBOARD )

    // @
    g_worldNormal   = GetLocalNormal();
    g_worldTangent  = GetLocalTangent();
    g_worldBinormal = GetLocalBinormal();

    // ]sKp邩H
#if ( VERTEX_ROTATION_MODE == VERTEX_ROTATION_MODE_USE )
    mat4 rotate     = MakeRotationMatrix( v_inRot.x, v_inRot.y, v_inRot.z );
    gl_Position     = rotate * scaledPos;
    g_worldNormal   = ( transpose( bldMat ) * rotate * vec4(g_worldNormal, 0.0) ).xyz;
    g_worldTangent  = ( transpose( bldMat ) * rotate * vec4(g_worldTangent, 0.0) ).xyz;
    g_worldBinormal = ( transpose( bldMat ) * rotate * vec4(g_worldBinormal, 0.0) ).xyz;
#else
    gl_Position     = scaledPos;
    g_worldNormal   = ( transpose( bldMat ) * vec4(g_worldNormal, 0.0) ).xyz;
    g_worldTangent  = ( transpose( bldMat ) * vec4(g_worldTangent, 0.0) ).xyz;
    g_worldBinormal = ( transpose( bldMat ) * vec4(g_worldBinormal, 0.0) ).xyz;
#endif

    // r{[h}gNXKp
    gl_Position     = gl_Position * bldMat;

    // [hWKp
    gl_Position.xyz = v_inWldPos.xyz + gl_Position.xyz;

#endif


    //--------------------------------------------------------------
    // _ϊ - Yr{[h
    //--------------------------------------------------------------
#if ( VERTEX_TRANSFORM_MODE == VERTEX_TRANSFORM_MODE_Y_BILLBOARD )

    // @
    g_worldNormal   = GetLocalNormal();
    g_worldTangent  = GetLocalTangent();
    g_worldBinormal = GetLocalBinormal();

#if ( VERTEX_ROTATION_MODE == VERTEX_ROTATION_MODE_USE )

    // ] + Y
    mat4 rotate     = MakeRotationMatrix( v_inRot.x, v_inRot.y, v_inRot.z );

    // Y]l
    vec4  pos  = v_inWldPos * rotate;
    vec4  eye  = eyePos * rotate;
    float rotY = atan( -(eye.x - pos.x), (eye.z - pos.z) );

    rotate *= MakeRotationMatrix( 0.0, -rotY, 0.0 );

#else
    // Y]l
    float rotY = atan( -(eyePos.x - v_inWldPos.x), (eyePos.z - v_inWldPos.z) );

    // Y
    mat4 rotate     = MakeRotationMatrix( 0.0, -rotY, 0.0 );
#endif

    gl_Position     = rotate * scaledPos;
    g_worldNormal   = ( rotate * vec4( g_worldNormal, 0.0   ) ).xyz;
    g_worldTangent  = ( rotate * vec4( g_worldTangent, 0.0  ) ).xyz;
    g_worldBinormal = ( rotate * vec4( g_worldBinormal, 0.0 ) ).xyz;

    // [hWKp
    gl_Position.xyz = v_inWldPos.xyz + gl_Position.xyz;

#endif



    //--------------------------------------------------------------
    // _ϊ - Œ
    //--------------------------------------------------------------
#if ( VERTEX_TRANSFORM_MODE == VERTEX_TRANSFORM_MODE_PLATE_XY || VERTEX_TRANSFORM_MODE == VERTEX_TRANSFORM_MODE_PLATE_XZ )

    vec4 	yzFlipPos;
    mat4    tempMat;

    // @
    g_worldNormal       = GetLocalNormal();
    g_worldTangent      = GetLocalTangent();
    g_worldBinormal     = GetLocalBinormal();

    // XYŒ
#if ( VERTEX_TRANSFORM_MODE == VERTEX_TRANSFORM_MODE_PLATE_XY )
    yzFlipPos.xyzw      = scaledPos.xyzw;
#endif
    // XZŒ
#if ( VERTEX_TRANSFORM_MODE == VERTEX_TRANSFORM_MODE_PLATE_XZ )
    yzFlipPos.xyzw      = scaledPos.xzyw;
    yzFlipPos.z         = -yzFlipPos.z;

    float tempNormalZ   = g_worldNormal.z;
    g_worldNormal.z     = g_worldNormal.y;
    g_worldNormal.y     = tempNormalZ;

    tempNormalZ         = g_worldTangent.z;
    g_worldTangent.z    = g_worldTangent.y;
    g_worldTangent.y    = tempNormalZ;

    tempNormalZ         = g_worldBinormal.z;
    g_worldBinormal.z   = g_worldBinormal.y;
    g_worldBinormal.y   = tempNormalZ;
#endif

    // ]sKp邩H
#if ( VERTEX_ROTATION_MODE == VERTEX_ROTATION_MODE_USE )
    mat4 rotate         = MakeRotationMatrix( v_inRot.x, v_inRot.y, v_inRot.z );
    gl_Position         = rotate * yzFlipPos;
    g_worldNormal       = ( rotate * vec4(g_worldNormal, 0.0) ).xyz;
    g_worldTangent      = ( rotate * vec4(g_worldTangent, 0.0) ).xyz;
    g_worldBinormal     = ( rotate * vec4(g_worldBinormal, 0.0) ).xyz;
#else
    gl_Position         = yzFlipPos;
#endif

    // G~b^}gNXKp
    tempMat[0]          = vec4( v_inEmtMat0.xyz, v_inWldPos.x );
    tempMat[1]          = vec4( v_inEmtMat1.xyz, v_inWldPos.y );
    tempMat[2]          = vec4( v_inEmtMat2.xyz, v_inWldPos.z );
    tempMat[3]          = vec4( 0.0, 0.0, 0.0, 1.0 );
    gl_Position         = gl_Position * tempMat;
    g_worldNormal       = ( vec4( g_worldNormal, 0.0 ) * tempMat ).xyz;
    g_worldTangent      = ( vec4( g_worldTangent, 0.0 ) * tempMat ).xyz;
    g_worldBinormal     = ( vec4( g_worldBinormal, 0.0 ) * tempMat ).xyz;
    
    
#endif




    //--------------------------------------------------------------
    // _ϊ - fBNViYr{[h 
    //--------------------------------------------------------------
#if ( VERTEX_TRANSFORM_MODE == VERTEX_TRANSFORM_MODE_DIRECTIONAL_Y )

    // @
    g_worldNormal = GetLocalNormal();
#ifndef MESH_TYPE_PRIMITIVE
	g_worldNormal.z *= -1;
#endif

    g_worldTangent = GetLocalTangent();
#ifndef MESH_TYPE_PRIMITIVE
	g_worldTangent.z *= -1;
#endif

    g_worldBinormal = GetLocalBinormal();
#ifndef MESH_TYPE_PRIMITIVE
	g_worldBinormal.z *= -1;
#endif

    upVector.xyz = eyeVec.xyz;

    basisY.xyz = v_inWldPosDf.xyz;
    basisY = normalize( basisY );

    basisX.x = (upVector.y * basisY.z) - (upVector.z * basisY.y);
    basisX.y = (upVector.z * basisY.x) - (upVector.x * basisY.z);
    basisX.z = (upVector.x * basisY.y) - (upVector.y * basisY.x);
    basisX = normalize( basisX );

    basisZ.x = (basisX.y * basisY.z) - (basisX.z * basisY.y);
    basisZ.y = (basisX.z * basisY.x) - (basisX.x * basisY.z);
    basisZ.z = (basisX.x * basisY.y) - (basisX.y * basisY.x);

    matVelLook[0][0] = basisX.x;
    matVelLook[1][0] = basisY.x;
    matVelLook[2][0] = basisZ.x;
    matVelLook[3][0] = 0.0;

    matVelLook[0][1] = basisX.y;
    matVelLook[1][1] = basisY.y;
    matVelLook[2][1] = basisZ.y;
    matVelLook[3][1] = 0.0;

    matVelLook[0][2] = basisX.z;
    matVelLook[1][2] = basisY.z;
    matVelLook[2][2] = basisZ.z;
    matVelLook[3][2] = 0.0;

    // ]sKp邩H
#if ( VERTEX_ROTATION_MODE == VERTEX_ROTATION_MODE_USE )
    mat4 rotate     = MakeRotationMatrix( v_inRot.x, v_inRot.y, v_inRot.z );
    gl_Position     = matVelLook * rotate * scaledPos;
    g_worldNormal   = ( (matVelLook * rotate) * vec4(g_worldNormal, 0.0) ).xyz;
    g_worldTangent  = ( (matVelLook * rotate) * vec4(g_worldTangent, 0.0) ).xyz;
    g_worldBinormal = ( (matVelLook * rotate) * vec4(g_worldBinormal, 0.0) ).xyz;
#else
    gl_Position     = matVelLook * scaledPos;
    g_worldNormal   = ( matVelLook * vec4(g_worldNormal, 0.0) ).xyz;
    g_worldTangent  = ( matVelLook * vec4(g_worldTangent, 0.0) ).xyz;
    g_worldBinormal = ( matVelLook * vec4(g_worldBinormal, 0.0) ).xyz;
#endif

    // [hWKp
    gl_Position.xyz = v_inWldPos.xyz + gl_Position.xyz;
#endif




    //--------------------------------------------------------------
    // _ϊ - fBNVi|S
    //--------------------------------------------------------------
#if ( VERTEX_TRANSFORM_MODE == VERTEX_TRANSFORM_MODE_DIRECTIONAL_POLYGON )

    // @
    g_worldNormal = GetLocalNormal();
#ifndef MESH_TYPE_PRIMITIVE
	g_worldNormal.z *= -1;
#endif

    g_worldTangent = GetLocalTangent();
#ifndef MESH_TYPE_PRIMITIVE
	g_worldTangent.z *= -1;
#endif

    g_worldBinormal = GetLocalBinormal();
#ifndef MESH_TYPE_PRIMITIVE
	g_worldBinormal.z *= -1;
#endif

    upVector.x      = v_inEmtMat0[1];
    upVector.y      = v_inEmtMat1[1];
    upVector.z      = v_inEmtMat2[1];

    basisY.xyz = v_inWldPosDf.xyz;
    basisY = normalize( basisY );

    basisX.x = (upVector.y * basisY.z) - (upVector.z * basisY.y);
    basisX.y = (upVector.z * basisY.x) - (upVector.x * basisY.z);
    basisX.z = (upVector.x * basisY.y) - (upVector.y * basisY.x);
    basisX = normalize( basisX );

    basisZ.x = (basisX.y * basisY.z) - (basisX.z * basisY.y);
    basisZ.y = (basisX.z * basisY.x) - (basisX.x * basisY.z);
    basisZ.z = (basisX.x * basisY.y) - (basisX.y * basisY.x);

    matVelLook[0][0] = basisX.x;
    matVelLook[1][0] = basisY.x;
    matVelLook[2][0] = basisZ.x;
    matVelLook[3][0] = 0.0;

    matVelLook[0][1] = basisX.y;
    matVelLook[1][1] = basisY.y;
    matVelLook[2][1] = basisZ.y;
    matVelLook[3][1] = 0.0;

    matVelLook[0][2] = basisX.z;
    matVelLook[1][2] = basisY.z;
    matVelLook[2][2] = basisZ.z;
    matVelLook[3][2] = 0.0;

    // ]sKp邩H
#if ( VERTEX_ROTATION_MODE == VERTEX_ROTATION_MODE_USE )
    mat4 rotate     = MakeRotationMatrix( v_inRot.x, v_inRot.y, v_inRot.z );
    rotMat          = matVelLook * rotate;
    gl_Position     = rotMat * scaledPos;
    g_worldNormal  = ( rotMat * vec4(g_worldNormal, 0.0) ).xyz;
    g_worldTangent  = ( rotMat * vec4(g_worldTangent, 0.0) ).xyz;
    g_worldBinormal = ( rotMat * vec4(g_worldBinormal, 0.0) ).xyz;
#else
    gl_Position     = matVelLook * scaledPos;
    g_worldNormal  = ( matVelLook * vec4(g_worldNormal, 0.0) ).xyz;
    g_worldTangent  = ( matVelLook * vec4(g_worldTangent, 0.0) ).xyz;
    g_worldBinormal = ( matVelLook * vec4(g_worldBinormal, 0.0) ).xyz;
#endif

    // [hWKp
    gl_Position.xyz     = v_inWldPos.xyz + gl_Position.xyz;
#endif

    // EW𒲐
    AdjustmentWorldPosition();

    // [hW
    g_worldVertexPos.xyz	= gl_Position.xyz;

    // XN[Wn֕ϊ
    gl_Position             = gl_Position * vpMat;

    // Zւ̃ItZbg
    gl_Position.z          -= cameraOffset * ( 1 - gl_Position.z / gl_Position.w );


    // eNX`W
#ifndef MESH_TYPE_PRIMITIVE
    // p[eBN̏ꍇ
    float sinZ = sin( -uvRotate );
    float cosZ = cos( -uvRotate );
    float texu = v_inPos.x * cosZ - v_inPos.y * sinZ;
    float texv = v_inPos.x * sinZ + v_inPos.y * cosZ; 
    v_outTexCoord.x = ( texu + 0.5 ) * uvInitScaleX  + uvTransX - ( 1.0 - uvScaleX ) * texu;
    v_outTexCoord.y = ( texv - 0.5 ) * -uvInitScaleY + uvTransY + ( 1.0 - uvScaleY ) * texv;

    sinZ = sin( -uvSubRotate );
    cosZ = cos( -uvSubRotate );
    texu = v_inPos.x * cosZ - v_inPos.y * sinZ;
    texv = v_inPos.x * sinZ + v_inPos.y * cosZ;
    v_outMultiTexCoord.x = ( texu + 0.5 ) * uvSubInitScaleX  + uvSubTransX - ( 1.0 - uvSubScaleX ) * texu;
    v_outMultiTexCoord.y = ( texv - 0.5 ) * -uvSubInitScaleY + uvSubTransY + ( 1.0 - uvSubScaleY ) * texv;

#else
    // v~eBȕꍇ
    float sinZ = sin( uvRotate );
    float cosZ = cos( uvRotate );
    float texu = ( v_inTexCoord.x * uvInitScaleX - 0.5 ) * cosZ - ( v_inTexCoord.y * uvInitScaleY - 0.5 ) * sinZ;
    float texv = ( v_inTexCoord.x * uvInitScaleX - 0.5 ) * sinZ + ( v_inTexCoord.y * uvInitScaleY - 0.5 ) * cosZ;
    v_outTexCoord.x = texu * v_inTexAnim.z + uvTransX + 0.5;
    v_outTexCoord.y = texv * v_inTexAnim.w + uvTransY + 0.5;


    sinZ = sin( uvSubRotate );
    cosZ = cos( uvSubRotate );
    texu = ( v_inTexCoord.x * uvInitScaleX - 0.5 ) * cosZ - ( v_inTexCoord.y * uvInitScaleY - 0.5 ) * sinZ;
    texv = ( v_inTexCoord.x * uvInitScaleX - 0.5 ) * sinZ + ( v_inTexCoord.y * uvInitScaleY - 0.5 ) * cosZ;
    v_outMultiTexCoord.x = texu * uvSubScaleX + uvSubTransX + 0.5;
    v_outMultiTexCoord.y = texv * uvSubScaleY + uvSubTransY + 0.5;


#endif

    // J[0/1 
    v_outColor0 = v_inColor0 * emitterColor0;
    v_outColor1 = v_inColor1 * emitterColor1;

    // v~eBu_J[
#ifdef MESH_TYPE_PRIMITIVE
    v_outPrimitiveColor = v_inColor;
#endif

    // fvX擾p
    v_outPos = matTexture * gl_Position;

    // [x/t[obt@QƗp
    matTexture[0][0] = depthBufferTexMat.x * 0.5;
    matTexture[1][1] = depthBufferTexMat.y * TEXCOORD_ADJUSTMENT;
    matTexture[3][0] = depthBufferTexMat.z + 0.5;
    matTexture[3][1] = depthBufferTexMat.w + 0.5;
    v_outDepthTexCoordProj = matTexture * gl_Position;

    matTexture[0][0] = frameBufferTexMat.x * 0.5;
    matTexture[1][1] = frameBufferTexMat.y * TEXCOORD_ADJUSTMENT;
    matTexture[3][0] = frameBufferTexMat.z + 0.5;
    matTexture[3][1] = frameBufferTexMat.w + 0.5;
    v_outFrameTexCoordProj = matTexture * gl_Position;

    // [U[Ǝ̒_ŏI
    FinalAdjustmentVertexProcess();
}
