/*---------------------------------------------------------------------------*
  Project:  NintendoWare
  File:     eft_ParticleDeclaration.fsh
  
  Copyright (C)2011-2012 Nintendo All rights reserved.
  
  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.
  
  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/



//------------------------------------------------------------------------------
// JX^}CY`
//------------------------------------------------------------------------------
// #define USE_USR_FINAL_ADJUSTMENT_FRAGMENT_COLOR        		// [U[Ǝ̃tOgo̓J[ŏI


//------------------------------------------------------------------------------
// `
//------------------------------------------------------------------------------
// ƂȂtOgVF[_
#define FRAGMENT_PARTICLE_SHADER_MODE_NORMAL		(0)		    // ʏVF[_
#define FRAGMENT_PARTICLE_SHADER_MODE_REFRECT		(1)		    // ܃VF[_
#define FRAGMENT_PARTICLE_SHADER_MODE_DISTORTION	(2)		    // c݃VF[_

// \tg@\𗘗p邩H
#define FRAGMENT_SOFT_EDGE_NO_USE			        (0)		    // \tgGbW𗘗pȂ
#define FRAGMENT_SOFT_EDGE_USE				        (1)		    // \tgGbW𗘗p

// gpJ[vZ
#define FRAGMENT_COLOR_MODE_COLOR			        (0)		    // Color0
#define FRAGMENT_COLOR_MODE_TEXTURE			        (1)		    // Color0 * Texture
#define FRAGMENT_COLOR_MODE_TEXTURE_INTERPOLATE		(2)		    // Color0 * Texture + Color1 * ( 1 - Texture )
#define FRAGMENT_COLOR_MODE_NORMAL_ADD			    (3)		    // Color0 * Texture + Color1

// gp郿vZ
#define FRAGMENT_ALPHA_MODE_MOD				        (0)		    // TextureA * Alpha
#define FRAGMENT_ALPHA_MODE_SUB				        (1)         // ( TextureA - ( 1 - Alpha ) ) * 2
#define FRAGMENT_ALPHA_MODE_MOD_R			        (2)		    // TextureR * Alpha
#define FRAGMENT_ALPHA_MODE_SUB_R			        (3)		    // ( TextureR - ( 1 - Alpha ) ) * 2

// gpeNX`
#define FRAGMENT_TEXTURE_MODE_FIRST	    		    (0)		    // eNX`1
#define FRAGMENT_TEXTURE_MODE_SECOND			    (1)		    // eNX`2

// R|Wbg
#define FRAGMENT_COMPOSITE_MUL			            (0)		    // Z
#define FRAGMENT_COMPOSITE_ADD			            (1)		    // Z
#define FRAGMENT_COMPOSITE_SUB			            (2)		    // Z

// ͒l̈
#define FRAGMENT_PARAMETER_INPUT_OPT_SRC            (0)		    // ͒l̂܂܎gp
#define FRAGMENT_PARAMETER_INPUT_OPT_ONE            (1)		    // ͒l1.0ƂĈ




//------------------------------------------------------------------------------
// eNX`Tv
//------------------------------------------------------------------------------
uniform sampler2D s_firstTexture;					// 1ڃeNX`Tv\
uniform sampler2D s_secondTexture;					// 2ڃeNX`Tv\
uniform sampler2D s_frameBufferTexture;			    // t[obt@eNX`Tv\
uniform sampler2D s_depthBufferTexture;				// fvXobt@eNX`Tv\




//------------------------------------------------------------------------------
// jtH[ ubN
//------------------------------------------------------------------------------
uniform viewUniformBlock
{
    mat4    viewMat;						                // view        }gNX
    mat4    vpMat;						                    // view * proj }gNX
    mat4    bldMat;						                    // r{[h}gNX
    vec4    eyeVec;						                    // xNg
    vec4    eyePos;						                    // ʒu
    vec4    depthBufferTexMat;						        // fvXobt@eNX`p}gNX
    vec4    frameBufferTexMat;						        // t[obt@eNX`p}gNX
    vec4    viewParam;                                      // near / far / / /
};

#define     nearZ           viewParam.x                     // near
#define     farZ            viewParam.y                     // far



uniform emitterStaticUniformBlock
{
    vec4    uvScaleInit;                                    // eNX`XP[l
    vec4    rotBasis;                                       // ]ʒu( x / y / / / )
    vec4    u_shaderParam;                                  // VF[_p[^
};


#define     shaderParam0    u_shaderParam.x                 // VF[_p[^0
#define     shaderParam1    u_shaderParam.y                 // VF[_p[^1
#define     softEdgeDist    u_shaderParam.z                 // \tgGbW@tF[h
#define     softEdgeVolume  u_shaderParam.w                 // \tgGbW@{[l



//------------------------------------------------------------------------------
// _VF[_ 瑗Ăl
//------------------------------------------------------------------------------
in vec4     v_outColor0;                                    // J[0
in vec4     v_outColor1;                                    // J[1
in vec2     v_outTexCoord;                                  // eNX`W
in vec2     v_outMultiTexCoord;                             // }`eNX`W
in vec4     v_outPos;			                            // fvXl擾p
in vec4     v_outDepthTexCoordProj;		                    // eNX`fvXl擾p
in vec4     v_outFrameTexCoordProj;				            // eNX`t[l擾p
in vec4     v_outPrimitiveColor;				            // v~eBuJ[



//------------------------------------------------------------------------------
// J[o͐
// VXe͍ŏIJ[ɏ݂܂B
// ݐςꍇ́AJX^tOgVF[_[ɂāA
// OUTPUT_COLOR  #undef Ē`ĉB
//------------------------------------------------------------------------------
#define OUTPUT_COLOR gl_FragColor

