/*---------------------------------------------------------------------------*
  Project:  NintendoWare
  File:     eft_Stripe.vsh
  
  Copyright (C)2011-2012 Nintendo All rights reserved.
  
  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.
  
  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/



//---------------------------------------------------
// [U[Ǝ̒_ŏI( JX^}CY\ )
//---------------------------------------------------
#ifndef USE_USR_FINAL_ADJUSTMENT_VERTEX_PROCSS
void FinalAdjustmentVertexProcess(){}
#endif


//------------------------------------------------------------------------------
// `
//------------------------------------------------------------------------------
#define VERTEX_TRANSFORM_MODE_STRIPE			    (5)
#define VERTEX_TRANSFORM_MODE_COMPLEX_STRIPE		(6)



//------------------------------------------------------------------------------
// jtH[ ubN
//------------------------------------------------------------------------------
uniform stripeUniformBlock
{
    vec4    stParam;                        // CrossOff/CrossOn/CameraOffset/Particle Sacle
    vec4    uvScrollAnim;                   // Scroll eNX`Aj
    vec4    uvScaleRotateAnim0;             // Scale / Rotate eNX`Aj / w 
    vec4    uvScaleRotateAnim1;             // Scale / Rotate eNX`Aj / w 
    vec4    vtxColor0;                      // J[0
    vec4    vtxColor1;                      // J[1
    mat4    emitterMat;						// G~b^}gNX
};


//------------------------------------------------------------------------------
// ϊs
//------------------------------------------------------------------------------
#ifdef TARGET_WINDOWS
mat4 matTexture = mat4( 0.5,  0.0, 0.0, 0.0, 
                        0.0,  0.5, 0.0, 0.0, 
                        0.0,  0.0, 0.5, 0.0, 
                        0.5,  0.5, 0.5, 1.0 );
#endif
#ifdef TARGET_CAFE
mat4 matTexture = mat4( 0.5,  0.0, 0.0, 0.0, 
                        0.0, -0.5, 0.0, 0.0, 
                        0.0,  0.0, 0.5, 0.0, 
                        0.5,  0.5, 0.5, 1.0 );
#endif


//------------------------------------------------------------------------------
// Agr[g
//------------------------------------------------------------------------------
in vec4  v_inDir;       // is
in vec4  v_inOuter;     // XgCvE̕ZopxNg


//------------------------------------------------------------------------------
// XgCv@_VF[_
//------------------------------------------------------------------------------
void main(void)
{

// r{[h^CvXgCv
#ifdef STRIPE_TYPE_BILLBOARD
    // ʒu JɌ
    vec3 outer      = normalize( cross( eyeVec.xyz, v_inDir.xyz ) );
    gl_Position.xyz = v_inPos.xyz + outer.xyz * v_inOuter.w * 0.5;

    // @
    outer           = normalize( cross( v_inOuter.xyz, v_inDir.xyz ) );
    g_worldNormal   = ( outer.xyz * -1.0 );

#endif


// G~b^s^CvXgCv
#ifdef STRIPE_TYPE_EMITTER_MATRIX

    // ʒu
    vec3 outer      = normalize( cross( v_inOuter.xyz, v_inDir.xyz ) );
    gl_Position.xyz = v_inPos.xyz + 
                      v_inOuter.xyz * v_inOuter.w * stParam.x * 0.5 +                 // ʏ
                      outer.xyz     * v_inOuter.w * stParam.y /* stParam.w*/ * 0.5;      // NX

    //  @
    g_worldNormal   = ( outer.xyz * -1.0 );

#endif


// G~b^㉺^CvXgCv
#ifdef STRIPE_TYPE_EMITTER_UP_DOWN

    // ʒu
    vec3 outer      = normalize( cross( v_inOuter.xyz, v_inDir.xyz ) );
    gl_Position.xyz = v_inPos.xyz + 
                      v_inOuter.xyz * v_inOuter.w * stParam.x * 0.5 +                 // ʏ
                      outer.xyz     * v_inOuter.w * stParam.y /* stParam.w*/ * 0.5;      // NX

    // @
    g_worldNormal   = v_inOuter.xyz;
#endif


    gl_Position.w   = 1.0;

    // G~b^ɊSǏ]
#ifdef STRIPE_TYPE_EMITTER_COORD
    gl_Position             = gl_Position * emitterMat;
    g_worldNormal           = ( vec4( g_worldNormal, 0.0 ) * emitterMat ).xyz;
#endif
    gl_Position	            = gl_Position * vpMat;


    // Zւ̃ItZbg
    gl_Position.z           -= stParam.z * ( 1 - gl_Position.z / gl_Position.w );

    // J[
    v_outColor0.xyz			= vtxColor0.xyz;
    v_outColor0.w			= vtxColor0.w * v_inPos.w;
    v_outColor1.xyz			= vtxColor1.xyz;
    v_outColor1.w			= vtxColor1.w * v_inPos.w;

//    v_outColor0.xyz = g_worldNormal.xyz;

    // eNX`0 WAj
    float sinZ = sin( uvScaleRotateAnim0.z );
    float cosZ = cos( uvScaleRotateAnim0.z );
    v_outTexCoord.x = ( ( (v_inTexCoord.x - 0.5) ) * cosZ - ( (v_inTexCoord.y - 0.5) ) * sinZ ) * uvScaleRotateAnim0.x + uvScrollAnim.x + 0.5;
    v_outTexCoord.y = ( ( (v_inTexCoord.x - 0.5) ) * sinZ + ( (v_inTexCoord.y - 0.5) ) * cosZ ) * uvScaleRotateAnim0.y + uvScrollAnim.y + 0.5;

    // eNX`1 WAj
    sinZ = sin( uvScaleRotateAnim1.z );
    cosZ = cos( uvScaleRotateAnim1.z );
    v_outMultiTexCoord.x = ( ( (v_inTexCoord.z - 0.5) ) * cosZ - ( (v_inTexCoord.w - 0.5) ) * sinZ ) * uvScaleRotateAnim1.x + uvScrollAnim.z + 0.5;
    v_outMultiTexCoord.y = ( ( (v_inTexCoord.z - 0.5) ) * sinZ + ( (v_inTexCoord.w - 0.5) ) * cosZ ) * uvScaleRotateAnim1.y + uvScrollAnim.w + 0.5;

    // fvX擾p
    v_outPos = matTexture * gl_Position;

    // [x/t[obt@QƗp
    matTexture[0][0] = depthBufferTexMat.x * 0.5;
    matTexture[1][1] = depthBufferTexMat.y * TEXCOORD_ADJUSTMENT;
    matTexture[3][0] = depthBufferTexMat.z + 0.5;
    matTexture[3][1] = depthBufferTexMat.w + 0.5;
    v_outDepthTexCoordProj = matTexture * gl_Position;

    matTexture[0][0] = frameBufferTexMat.x * 0.5;
    matTexture[1][1] = frameBufferTexMat.y * TEXCOORD_ADJUSTMENT;
    matTexture[3][0] = frameBufferTexMat.z + 0.5;
    matTexture[3][1] = frameBufferTexMat.w + 0.5;
    v_outFrameTexCoordProj = matTexture * gl_Position;

    // [U[Ǝ̒_ŏI
    FinalAdjustmentVertexProcess();
}


